#include "splines.h"


CCRSpline::CCRSpline()
{
	JustPassed = 0;
	t = 0.0f;
	Delta = 0.01f;
	
	InterpPoint.x = 0.0f; InterpPoint.y = 0.0f; InterpPoint.z = 0.0f; 
	PreviousPoint.x = 0.0f; PreviousPoint.y = 0.0f; PreviousPoint.z = 0.0f;
	
	Point[0].x = 15.0f; Point[0].z = 95.6f; Point[0].y = 0.0f;
	Point[1].x = 15.0f; Point[1].z = 115.5f; Point[1].y = 0.0f;
	Point[2].x = 17.3f; Point[2].z = 142.5f; Point[2].y = 0.0f;
	Point[3].x = 29.3f; Point[3].z = 144.6f; Point[3].y = 0.0f;
	Point[4].x = 53.2f; Point[4].z = 145.9f; Point[4].y = 0.0f;
	Point[5].x = 57.9f; Point[5].z = 162.1f; Point[5].y = 0.0f;
	Point[6].x = 71.8f; Point[6].z = 168.8f; Point[6].y = 0.0f;
	Point[7].x = 79.1f; Point[7].z = 182.8f; Point[7].y = 0.0f;
	Point[8].x = 93.0f; Point[8].z = 189.3f; Point[8].y = 0.0f;
	Point[9].x = 98.2f; Point[9].z = 201.6f; Point[9].y = 0.0f;
	Point[10].x = 125.3f; Point[10].z = 205.4f; Point[10].y = 0.0f;
	Point[11].x = 152.6f; Point[11].z = 202.0f; Point[11].y = 0.0f;
	Point[12].x = 154.8f; Point[12].z = 187.6f; Point[12].y = 0.0f;
	Point[13].x = 158.0f; Point[13].z = 167.5f; Point[13].y = 0.0f;
	Point[14].x = 182.5f; Point[14].z = 165.5f; Point[14].y = 0.0f;
	Point[15].x = 211.9f; Point[15].z = 162.1f; Point[15].y = 0.0f;
	Point[16].x = 215.3f; Point[16].z = 132.3f; Point[16].y = 0.0f;
	Point[17].x = 215.4f; Point[17].z = 82.7f; Point[17].y = 0.0f;
	Point[18].x = 215.1f; Point[18].z = 46.8f; Point[18].y = 0.0f;
	Point[19].x = 211.7f; Point[19].z = 19.3f; Point[19].y = 0.0f;
	Point[20].x = 186.6f; Point[20].z = 16.4f; Point[20].y = 0.5f;
	Point[21].x = 186.2f; Point[21].z = 53.0f; Point[21].y = 0.2f;
	Point[22].x = 187.3f; Point[22].z = 88.3f; Point[22].y = 0.0f;
	Point[23].x = 181.9f; Point[23].z = 112.6f; Point[23].y = 0.0f;
	Point[24].x = 138.8f; Point[24].z = 116.0f; Point[24].y = 0.0f;
	Point[25].x = 95.1f; Point[25].z = 115.0f; Point[25].y = 0.0f;
	Point[26].x = 76.0f; Point[26].z = 110.9f; Point[26].y = 0.1f;
	Point[27].x = 72.6f; Point[27].z = 97.8f; Point[27].y = 0.0f;
	Point[28].x = 52.4f; Point[28].z = 94.8f; Point[28].y = 0.1f;
	Point[29].x = 34.8f; Point[29].z = 93.9f; Point[29].y = 0.0f;
}

CCRSpline::~CCRSpline()
{
	
}


Vector4 CCRSpline::Interpolate(void)
{
	float t2 = t * t;
	float t3 = t2 * t;

	Vector4 cp;

	cp.x =  0.5f * ((2 * cp1.x) + 
					(-cp0.x + cp2.x) * t +
				    (2 * cp0.x - 5*cp1.x + 4*cp2.x - cp3.x) * t2 +
					(-cp0.x + 3*cp1.x - 3*cp2.x + cp3.x) * t3);

	cp.y =  0.5f * ((2 * cp1.y) + 
					(-cp0.y + cp2.y) * t +
				    (2 * cp0.y - 5*cp1.y + 4*cp2.y - cp3.y) * t2 +
					(-cp0.y + 3*cp1.y - 3*cp2.y + cp3.y) * t3);
					
	cp.z =  0.5f * ((2 * cp1.z) + 
					(-cp0.z + cp2.z) * t +
				    (2 * cp0.z - 5*cp1.z + 4*cp2.z - cp3.z) * t2 +
					(-cp0.z + 3*cp1.z - 3*cp2.z + cp3.z) * t3);

	return cp;
}

Vector4 CCRSpline::GetVectorAlongSpline(void)
{
	Vector4 Tmp;
	
	Tmp = InterpPoint - PreviousPoint;
	return (Tmp.Normalise());
}


Matrix4x4 CCRSpline::GetMatrixAlongSpline(void)
{
	Matrix4x4 World;
	
	Vector4 Look = GetVectorAlongSpline();
		
	Vector4 Up = Vector4(0.0f, 1.0f, 0.0f, 1.0f);
	
	Vector4 Right = Look.Cross(Up);
	
	Up = Right.Cross(Look);
	
	World(0,0) = Right.x;
	World(0,1) = Right.y;
	World(0,2) = Right.z;
	World(0,3) = 0.0f;
	
	World(1,0) = Up.x;
	World(1,1) = Up.y;
	World(1,2) = Up.z;
	World(1,3) = 0.0f;
	
	World(2,0) = Look.x;
	World(2,1) = Look.y;
	World(2,2) = Look.z;
	World(2,3) = 0.0f;
		
	World(3,0) = InterpPoint.x;
	World(3,1) = InterpPoint.y;
	World(3,2) = InterpPoint.z;
	World(3,3) = 1.0f;
	
	return World;	
}

Vector4 CCRSpline::AdvanceAlongSpline(void)
{
	if(JustPassed == 0)
	{
		cp0 = Point[CONTROLPOINTS-1];
		cp1 = Point[JustPassed];
		cp2 = Point[JustPassed+1];
		cp3 = Point[JustPassed+2];
	}
	else if(JustPassed == CONTROLPOINTS -2)
	{
		cp0 = Point[CONTROLPOINTS - 3];
		cp1 = Point[CONTROLPOINTS - 2];
		cp2 = Point[CONTROLPOINTS - 1];
		cp3 = Point[0];
	}
	else if(JustPassed == CONTROLPOINTS - 1)
	{
		cp0 = Point[CONTROLPOINTS - 2];
		cp1 = Point[CONTROLPOINTS - 1];
		cp2 = Point[0];
		cp3 = Point[1];
	}
		else
		{
			cp0 = Point[JustPassed - 1];
			cp1 = Point[JustPassed];
			cp2 = Point[JustPassed + 1];
			cp3 = Point[JustPassed + 2];
		}
	
	PreviousPoint = InterpPoint;
	InterpPoint = Interpolate();
	t += Delta;
	
	if(t >= 1.0f)
	{
		JustPassed++;
		if(JustPassed == CONTROLPOINTS) JustPassed = 0;
		
		t = Delta;	
	}
	
	return InterpPoint;
	
}
